diff --git a/src/prepare.c b/src/prepare.c
index 5bdd627e..c694712a 100644
--- a/src/prepare.c
+++ b/src/prepare.c
@@ -51,6 +51,10 @@ static void pthreads_prepared_resource_dtor(zval *zv); /* }}} */
 static void pthreads_prepared_entry_static_members(pthreads_object_t* thread, zend_class_entry *candidate, zend_class_entry *prepared) {
 	if (candidate->default_static_members_count) {
 		int i;
+
+                if(prepared->default_static_members_table != NULL) {
+                        efree(prepared->default_static_members_table);
+                }
 		prepared->default_static_members_table = (zval*) ecalloc(
 			sizeof(zval), candidate->default_static_members_count);
 		prepared->default_static_members_count = candidate->default_static_members_count;
@@ -68,26 +72,8 @@ static void pthreads_prepared_entry_static_members(pthreads_object_t* thread, ze
 } /* }}} */
 
 /* {{{ */
-static zend_class_entry* pthreads_copy_entry(pthreads_object_t* thread, zend_class_entry *candidate, zend_bool prepare_static_members) {
-	zend_class_entry *prepared;
-
-	if (candidate->ce_flags & ZEND_ACC_ANON_CLASS) {
-		if (!(candidate->ce_flags & ZEND_ACC_ANON_BOUND)) {
-			return NULL;
-		}
-	}
-
-	prepared = (zend_class_entry*) emalloc(sizeof(zend_class_entry));
-	prepared->name = zend_string_new(candidate->name);
-	prepared->type = candidate->type;
-
-	zend_initialize_class_data(prepared, 1);
-
-	zend_hash_index_update_ptr(&PTHREADS_ZG(resolve), (zend_ulong) candidate, prepared);
-
-	prepared->ce_flags = candidate->ce_flags;
-	prepared->refcount = 1;
-
+static zend_class_entry* pthreads_complete_entry(pthreads_object_t* thread, zend_class_entry *candidate, zend_class_entry *prepared, zend_bool prepare_static_members) {
+    
 	if (candidate->parent) {
 		if (zend_hash_index_exists(&PTHREADS_ZG(resolve), (zend_ulong) candidate->parent)) {
 			prepared->parent = zend_hash_index_find_ptr(&PTHREADS_ZG(resolve), (zend_ulong) candidate->parent);
@@ -184,9 +170,12 @@ static zend_class_entry* pthreads_copy_entry(pthreads_object_t* thread, zend_cla
 		
 		ZEND_HASH_FOREACH_STR_KEY_PTR(&candidate->function_table, key, value) {	
 			zend_string *name = zend_string_new(key);
-			value = pthreads_copy_function(value);
-			zend_hash_add_ptr(
-				&prepared->function_table, name, value);
+                        
+                        if (!zend_hash_exists(&prepared->function_table, name)) {
+                                value = pthreads_copy_function(value);
+                                zend_hash_add_ptr(
+                                        &prepared->function_table, name, value);
+                        }
 			zend_string_release(name);
 		} ZEND_HASH_FOREACH_END();
 	}
@@ -276,6 +265,10 @@ while(0)
 	
 	if (candidate->default_properties_count) {
 		int i;
+                
+                if(prepared->default_properties_table != NULL) {
+                        efree(prepared->default_properties_table);
+                }
 		prepared->default_properties_table = emalloc(
 			sizeof(zval) * candidate->default_properties_count);
 
@@ -297,16 +290,6 @@ while(0)
 	if(prepare_static_members) {
 		pthreads_prepared_entry_static_members(thread, candidate, prepared);
 	}
-	
-	memcpy(&prepared->info.user, &candidate->info.user, sizeof(candidate->info.user));
-
-	if ((thread->options & PTHREADS_INHERIT_COMMENTS) &&
-	   (candidate->info.user.doc_comment)) {
-        	prepared->info.user.doc_comment = zend_string_new(candidate->info.user.doc_comment);
-    	} else prepared->info.user.doc_comment = NULL;
-	
-	if (prepared->info.user.filename)
-		prepared->info.user.filename = zend_string_new(candidate->info.user.filename);
 
 	{
 		zend_string *key;
@@ -359,6 +342,35 @@ while(0)
 	return prepared;
 } /* }}} */
 
+/* {{{ */
+static zend_class_entry* pthreads_copy_entry(pthreads_object_t* thread, zend_class_entry *candidate, zend_bool prepare_static_members) {
+	zend_class_entry *prepared;
+
+	prepared = (zend_class_entry*) emalloc(sizeof(zend_class_entry));
+	prepared->name = zend_string_new(candidate->name);
+	prepared->type = candidate->type;
+
+	zend_initialize_class_data(prepared, 1);
+
+	zend_hash_index_update_ptr(&PTHREADS_ZG(resolve), (zend_ulong) candidate, prepared);
+
+	prepared->ce_flags = candidate->ce_flags;
+	prepared->refcount = 1;
+	
+	memcpy(&prepared->info.user, &candidate->info.user, sizeof(candidate->info.user));
+
+	if ((thread->options & PTHREADS_INHERIT_COMMENTS) &&
+	   (candidate->info.user.doc_comment)) {
+        	prepared->info.user.doc_comment = zend_string_new(candidate->info.user.doc_comment);
+    	} else prepared->info.user.doc_comment = NULL;
+	
+	if (prepared->info.user.filename) {
+		prepared->info.user.filename = zend_string_new(candidate->info.user.filename);
+	}
+	
+	return pthreads_complete_entry(thread, candidate, prepared, prepare_static_members);
+} /* }}} */
+
 /* {{{ */
 static inline int pthreads_prepared_entry_function_prepare(zval *bucket, int argc, va_list argv, zend_hash_key *key) {
 	zend_function *function = (zend_function*) Z_PTR_P(bucket);
@@ -410,6 +422,10 @@ zend_class_entry* pthreads_prepared_entry_internal(pthreads_object_t* thread, ze
 
 	if ((prepared = zend_hash_find_ptr(EG(class_table), lookup))) {
 	    zend_string_release(lookup);
+		
+		if(prepared->create_object == NULL && candidate->create_object != NULL) {
+			return pthreads_complete_entry(thread, candidate, prepared, prepare_static_members);
+		}
 		return prepared;
 	}
 	
diff --git a/tests/inherited-anon-class-outside-context.phpt b/tests/inherited-anon-class-outside-context.phpt
new file mode 100644
index 00000000..c60bdaf8
--- /dev/null
+++ b/tests/inherited-anon-class-outside-context.phpt
@@ -0,0 +1,73 @@
+--TEST--
+Basic anonymous class support, fix #505
+--DESCRIPTION--
+Unbound anon class causing segfaults, we delay copy but still cannot serialize the anon
+--FILE--
+<?php
+class Test extends Thread {
+	/**
+	 * doccomment run
+	 */
+	public function run() {
+		$this->alive = true;
+		/**
+		 * doccomment anonymous
+		 */
+		$this->anonymous = new class extends Thread {
+			const CONSTANT = 'constant';
+			/**
+			 * @var
+			 */
+			public $pubProp;
+			protected $protProp;
+			private $privProp;
+			public static $staticProp;
+			public function run() {
+				var_dump('anonymous run');
+				$this->ready = true;
+			}
+			public function method() {
+				var_dump('method executed');
+			}
+			public static function staticMethod() {}
+		};
+		var_dump($this->anonymous);
+		$this->anonymous->start();
+		$this->anonymous->join();
+		while($this->alive) {}
+	}
+}
+$test = new Test();
+$test->start();
+while(true) {
+	if(isset($test->anonymous, $test->anonymous->ready)) {
+		var_dump($test->anonymous);
+		$test->anonymous->run();
+		$test->anonymous->method();
+		$test->alive = false;
+		break;
+	}
+}
+$test->join();
+--EXPECT--
+object(class@anonymous)#2 (3) {
+  ["pubProp"]=>
+  NULL
+  ["protProp"]=>
+  NULL
+  ["privProp"]=>
+  NULL
+}
+string(13) "anonymous run"
+object(class@anonymous)#2 (4) {
+  ["pubProp"]=>
+  NULL
+  ["protProp"]=>
+  NULL
+  ["privProp"]=>
+  NULL
+  ["ready"]=>
+  bool(true)
+}
+string(13) "anonymous run"
+string(15) "method executed"
\ No newline at end of file
diff --git a/tests/inherited-anon-class.phpt b/tests/inherited-anon-class.phpt
new file mode 100644
index 00000000..14c3ff4a
--- /dev/null
+++ b/tests/inherited-anon-class.phpt
@@ -0,0 +1,17 @@
+--TEST--
+Test fix for #658 with inheritance
+--DESCRIPTION--
+Unbound anon class causing segfaults, we delay copy but still cannot serialize the anon
+--FILE--
+<?php
+$task = new class extends Thread {
+    public function run()
+    {
+        $this->prop = new class extends Threaded {};
+		var_dump($this->prop);
+    }
+};
+$task->start() && $task->join();
+--EXPECT--
+object(class@anonymous)#2 (0) {
+}
\ No newline at end of file
diff --git a/tests/no-inheritance-anon-class.phpt b/tests/no-inheritance-anon-class.phpt
new file mode 100644
index 00000000..19adbc6e
--- /dev/null
+++ b/tests/no-inheritance-anon-class.phpt
@@ -0,0 +1,16 @@
+--TEST--
+Test fix for #659
+--DESCRIPTION--
+Unbound anon class causing segfaults, we delay copy but still cannot serialize the anon
+--FILE--
+<?php
+$task = new class extends Thread {
+    public function run()
+    {
+        $this->prop = new class {};
+		var_dump($this->prop); /* we do expect null: anon classes cannot be serialized */
+    }
+};
+$task->start() && $task->join();
+--EXPECT--
+NULL
\ No newline at end of file
